;;;   ADimEdit.LSP
;;;   Copyright (C) 2002 by WindEnergo LTD, Babichuk A.V.
;;;            ofice phone: (044)219-40-09, 219-46-68.
;;;            E-Mail     : alexbabichuk@hotmail.com
;;;
;;;   C:DEA - edit a dimension, dialogue for use with the AutoCAD.
;;;
;;;   Uses adimedit.dcl for the dialogue definition.
;;;###############################################################
(defun setdiametr (/ kol a)
  (setq kol (strlen text))
  (if (> kol 3)
    (progn
      (setq a (substr text 1 3))
      (if (or (= a "%%c") (= a "%%C"))
	(setq text (substr text 4)
	      dia  1
	      txt0 "1"
	)
      )
    )
  )
)

(defun setdegres (/ kol a)
  (setq kol (strlen text))
  (if (> kol 3)
    (progn
      (setq a (substr text (- kol 2)))
      (if (or (= a "%%d") (= a "%%D"))
	(setq text (substr text 1 (- kol 3))
	      deg  1
	      txt5 "1"
	)
      )
    )
  )
)

(defun plusminus (/ kol a)
  (setq	kol (strlen text)
	num 1
	yes nil
  )
  (if (> kol 3)
    (while (<= num (- kol 3))
      (setq a (substr text num 3))
      (if (or (= a "%%p") (= a "%%P"))
	(progn
	  (setq	txt1   (substr text 1 (1- num))
		tol1   (substr text (+ num 3))
		tol2   (strcat "-" tol1)
		tol1   (strcat "+" tol1)
		sim    1
		simetr "1"
		num    (1+ kol)
	  )
	  nil
	)
	(progn
	  (setq num (1+ num))
	  T
	)
      )
    )
  )
)

(defun settxt1 (/ yes kol num a)
  (setq	kol  (strlen text)
	txt1 ""
	num  1
	yes  nil
  )
  (while (<= num kol)
    (setq a (substr text num 1))
    (if	(= a "\\")
      (setq text (substr text num)
	    num	 (1+ kol)
	    yes	 T
      )
      (setq txt1 (strcat txt1 a)
	    num	 (1+ num)
      )
    )
  )
  (if (= yes nil)
    (setq text "")
  )
)

(defun settxt2 (/ kol num a)
  (setq	kol (strlen text)
	num 1
  )
  (while (<= num kol)
    (setq a (substr text num 1))
    (if	(= a "S")
      (setq text (substr text (1+ num))
	    num	 (1+ kol)
      )
      (setq num	 (1+ num))
    )
  )
  
  (setq	kol (strlen text)
	num 1
  )
  (while (<= num kol)
    (setq a (substr text num 1))
    (if	(= a "^")
      (setq text (substr text (1+ num))
	    num	 (1+ kol)
      )
      (setq tol1 (strcat tol1 a)
	    num	 (1+ num)
      )
    )
  )  
)

(defun settxt3 (/ kol num a) 
  (setq	kol (strlen text)
	num 1
  )
  (while (<= num kol)
    (setq a (substr text num 1))
    (if	(= a ";")
      (setq text (substr text (1+ num))
	    num	 (1+ kol)
      )
      (setq tol2 (strcat tol2 a)
	    num	 (1+ num)
      )
    )
  )  
)

(defun settxt4 (/ kol num a)
  (setq	kol (strlen text)
	num 1
  )
  (while (<= num kol)
    (setq a (substr text num 1))
    (if	(= a "*")
      (setq num	 (1+ kol)
	    txt4 "1"
	    blk	 1
      )
      (setq num (1+ num))
    )
  )
)

(defun delplus (a)
  (setq b (substr a 1 1))
  (if (or (= b "+") (= b "-"))
    (substr a 2)
    a
  )
)

(defun c:dea (/ obj data dcl_id cod)
  (setvar "CMDECHO" 0)
  (setq	obj    (entsel)
	data   (entget (car obj))
	dcl_id (load_dialog "Adimedit.dcl")
	cod    0
	blk    0
	txt0   "0"
	txt1   ""
	txt2   ""
	txt4   "0"
	txt5   "0"
	tol1   ""
	tol2   ""
	text2  ""
	dia    0
	deg    0
	simetr "0"
	sim    0
  )
  (if (eq (cdr (assoc 0 data)) "DIMENSION")
    (progn
      (setq text_obj (assoc 1 data)
	    text     (cdr text_obj)
      )
      (setq dim_obj (assoc 42 data)
	    dim_txt (cdr dim_obj)
      )
      (setq dim_txt (rtos dim_txt))
      (if (= text "")
	(setq text "<>"
	      txt1 "<>"
	)
	(progn
	  (setdiametr)
	  (setdegres)
	  (if (plusminus)
	    (progn
	      (settxt1)
	      (settxt2)
	      (settxt3)
	      (settxt4)
	    )
	  )
	)
      )
      (redraw (car obj) 3)

      (if (not (new_dialog "adimedit" dcl_id))
	(exit)
      )
      (set_tile  "edit1"   txt1)
      (set_tile  "edit2"   txt2)
      (set_tile  "toler1"  tol1)
      (set_tile  "toler2"  tol2)
      (set_tile  "dim_txt" dim_txt)
      (set_tile  "block1"  txt4)
      (set_tile  "simm"    simetr)
      (set_tile  "diam"    txt0)
      (set_tile  "degr"    txt5)
      (mode_tile "edit1"   2)
      (mode_tile "dim_txt" 1)
      (mode_tile "block2"  1)

      (action_tile "edit1" "(setq text $value)")
      (action_tile "edit2" "(setq text2 $value)")
      (action_tile "toler1" "(setq tol1 $value)")
      (action_tile "toler2" "(setq tol2 $value)")
      (action_tile
	"block1"
	"(if (= blk 0) (setq blk 1) (setq blk 0))"
      )
      (action_tile
	"simm"
	"(if (= sim 0) (setq sim 1) (setq sim 0))"
      )
      (action_tile
	"diam"
	"(if (= dia 0) (setq dia 1) (setq dia 0))"
      )
      (action_tile
	"degr"
	"(if (= deg 0) (setq deg 1) (setq deg 0))"
      )
      (action_tile "accept" "(done_dialog 1) (setq flag T)")
      (action_tile "cancel" "(done_dialog 0) (setq flag nil)")
      (start_dialog)

      (if (not (or (= tol1 "") (= tol1 nil)))
	(setq cod 1)
      )
      (if (not (or (= tol2 "") (= tol2 nil)))
	(setq cod (+ cod 2))
      )
      (if (not (or (= flag nil) (= text "") (= text nil) (= text " "))
	  )
	(progn
	  (if (= sim 1)
	    (setq text (strcat text "%%p" (delplus tol1)))
	    (progn
	      (cond
		((= cod 1)
		 (setq
		   text	(strcat text "\\H.7x;\\S" tol1 "^;\\H1.428x;")
		 )
		)
		((= cod 2)
		 (setq
		   text	(strcat text "\\H.7x;\\S^" tol2 ";\\H1.428x;")
		 )
		)
		((= cod 3)
		 (setq text (strcat text	 "\\H.7x;\\S"
				    tol1	 "^"
				    tol2	 ";\\H1.428x;"
				   )
		 )
		)
	      )
	    )
	  )
	  (if (not (or (= text2 nil) (= text2 "")))
	    (setq text (strcat text text2))
	  )
	  (if (= dia 1)
	    (setq text (strcat "%%c" text))
	  )
	  (if (= deg 1)
	    (setq text (strcat text "%%d"))
	  )
	  (if (= blk 1)
	    (setq text (strcat text "\\S*^;"))
	  )
	  (setq	text (cons '1 text)
		data (subst text text_obj data)
	  )
	  (entmod data)
	)
      )
      (redraw (car obj) 4)
      (if (= flag T)
	(if (= cod 2)
	  (progn
	    (setvar "DIMGAP" (* (getvar "DIMGAP") 2))
	    (command "_-dimstyle" "_apply" (car obj) "")
	    (command "_-dimstyle" "_restore" "MM")
	  )
	  (command "_-dimstyle" "_apply" (car obj) "")
	)
      )
    )
  )
  (setvar "CMDECHO" 1)
)
(princ)
